/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.defaultimpl.listener;

import java.util.Map;

import com.topcoder.network.synchronization.bean.Message;
import com.topcoder.network.synchronization.defaultimpl.ServiceState;
import com.topcoder.network.synchronization.protocol.MessageListener;

/**
 * @author TCSDESIGNER
 * @version 1.0
 */
public class CommunicateMessageListener extends MessageListener {

    /**
     * Represents the state of this peer group service.
     */
    private ServiceState state = null;
    
    /**
     * Represents the communicate messages received from the receiver.
     */
    private Map communicateMessages = null;
    
    public CommunicateMessageListener(Map communicationMessages) {
        
    }
    
    /**
     * Deal COMMUNICATE_MESSAGE from receiver.
     * 
     * 1.  if the message is COMMUNICATE_MESSAGE, if it's turn property
     * is same as the turn property in service state, put this message to communicateMessages map.
     * 
     * 2. if this message is a vote for a particular message, and if the voted message is not in this applicationMessages, 
     * send a REQUEST_MESSAGE to request that message. 
     * 
     * 3. if the message is not COMMUNICATE_MESSAGE, pass it to the next listener if available.  
     * 
     */
    public void dealMessage(Message message) {
        

    }

}
