/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.bean;

import java.util.HashMap;
import java.util.Map;
import java.io.*;

/**
 * Every class extends this class will support attributes.
 * 
 * @author TCSDESIGNER
 * @version 1.0
 */
public class AttributeSupportedObject implements Serializable {
    
    /**
     * Represents the attributes in the class, the key and the value are both Object.
     * Can be empty, not null. 
     */
    private Map attributes = new HashMap();
    
    /**
     * Add one attribute to this object.
     * Simply call attributes.put(key, value);
     * 
     * @param key the key of the attribute
     * @param value the value of the attribute
     */
    public void addAttribute(Object key, Object value) {
        
    }
    
    /**
     * Remove the attribute with specified key from this object.
     * Simply call attributes.remove(key);
     * 
     * @param key the key of the attribute to remove
     */
    public void removeAttribute(Object key) {
        
    }
    
    /**
     * Get the attribute with specified key
     * 
     * @param key the key of the attribute to get
     * @return the attribute with specified key
     */
    public Object getAttribute(Object key) {
        return null;
    }

    /**
     * Clear all the attributes in the object.
     * 
     * attribute.clear();
     *
     */
    public void clearAttributes() {
        
    }
    
    /**
     * Return all the attributes in the object.
     * Simply call return new HashMap(attributes);
     * 
     * @return the shallow copy of the attributes
     */
    public Map getAttributes() {
        return null;
    }

}
