/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.defaultimpl;


/**
 * This class provides the funcationality to start a thread to check whether this peer is alive 
 * in the peer group.
 * 
 * @author TCSDESIGNER
 * @version 1.0
 */
public class KeepAliveEngine implements Runnable {
    
    /**
     * Represents the time interval to send a KEEPALIVE_MESSAGE and check this peer whether it is alive.
     */
    private int timeInterval = 60000;
    
    /**
     * Represents whether this engine is started.
     */
    private boolean start = true;
    
    /**
     * Represents the group service it keeps alive for.
     */
    private SynchronizedPeerGroupService group = null;
    
    /**
     * Constructor.
     * 
     * @param group the group service it keeps alive for
     */
    public KeepAliveEngine(SynchronizedPeerGroupService group) {
        
    }
    
    /**
     * Start a new thread to send KEEPALIVE_MESSAGEs and receive the reply 
     * from the peers in the peer group.
     * If the replies can't received, this engine will stop the whole group service. 
     */
    public void run() {
        /*
        while (start && group.state.getState() != ServiceState.DEAD) {
            
            try {
                Message keepMeAlive = new Message(IDGeneratorUtil.getNextId(), group.ownHeader, Message.REQUEST_MESSAGE);
                keepMeAlive.addAttribute("keep_me_alive", "true");
                
                group.keepAliveMessages.clear();
                group.send(keepMeAlive);                
                Thread.sleep(timeInterval);
                
                Set peers = new HashSet();
                for (Iterator it = group.keepAliveMessages.iterator(); it.hasNext(); ) {
                    Message msg = (Message) it.next();
                    if (keepMeAlive.getMessageId().equals(msg.getAttribute("keep_you_alive"))) {
                        peers.add(msg.getHeader().getPeerId());
                    }
                }
                if (((double) peers.size()) / (double)group.getGroupInfo().getAllPeers().size() < group.getGroupInfo().getKeepAlivePercent()) {
                    group.state.setState(ServiceState.DEAD);
                    start = false;
                }
                Thread.sleep(timeInterval);
            } catch (InterruptedException e) {
                
            } catch (DistributedProtocolException e) {
                group.state.setState(ServiceState.DEAD);
                start = false;
            }
        }
        */
    }
    
    public void stop() {
        
        
    }
    
    public void setTimeInterval(int time) {
        
    }
    
    public int getTimeInterval() {
        return timeInterval;
    }
}
